﻿

String.prototype.trim = function () {
	return this.replace(/^\s+|\s+$/g, "");
};

function calcolaIBANeCIN() {
	var contoCorrente = document.getElementById("ABI").value
		+ document.getElementById("CAB").value
		+ document.getElementById("CC").value;
	var aa = "A0B1C2D3E4F5G6H7I8J9K#L#M#N#O#P#Q#R#S#T#U#V#W#X#Y#Z#-#.# #";
	var bb = "B1A0K#P#L#C2Q#D3R#E4V#O#S#F5T#G6U#H7M#I8N#J9W#Z#Y#X# #-#.#";
	var dd = 0;
	var iban = "";
	var tabella = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	for (var ii = 1; ii < 22; ii += 2) {
		dd = dd + Math.floor(aa.indexOf(contoCorrente.charAt(ii)) / 2);
	}
	for (var ii = 0; ii < 22; ii += 2) {
		dd = dd + Math.floor(bb.indexOf(contoCorrente.charAt(ii)) / 2);
	}
	dd = dd - (Math.floor(dd/26)*26);

	document.getElementById("CIN").value = aa.charAt(dd*2);
	cc1 = document.getElementById("CIN").value + contoCorrente+"IT"+"00";

	for (var iban1 = 0; iban1 < cc1.length; iban1++) {
		iban += tabella.indexOf(cc1.charAt(iban1));
	}

	var divisore = 97;
	var div1 = ""
	for (var ciclo1 = 0; ciclo1 < iban.length; ciclo1++) {
		div1 = div1 + iban.charAt(ciclo1);
		if (div1 < divisore) {
			continue;
		}
		else {
			div1 = div1 % divisore;
		}
	}

	iban = 98 - div1;
	iban = "0" + iban;
	iban = iban.charAt(iban.length - 2) + iban.charAt(iban.length - 1);
	document.getElementById("IBAN").value = "IT" + iban
		+ document.getElementById("CIN").value + contoCorrente;
	var header = "<tr><th>ABI</th><th>CAB</th><th>C/C</th><th>CIN</th><th>IBAN</th></tr>";
	var result = "<tr><td>" + document.getElementById("ABI").value
		+ "</td><td>" + document.getElementById("CAB").value
		+ "</td><td>" + document.getElementById("CC").value
		+ "</td><td>" + document.getElementById("CIN").value
		+ "</td><td>" + document.getElementById("IBAN").value
		+ "</td></tr>";

	var elem = document.getElementById("risultati");
	elem.innerHTML = "<table border='1'><tbody>" + header + result + "</tbody></table>";
}

function verificaABI() {
	var elem = document.getElementById("ABI");
	elem.value = elem.value.trim();
	if (elem.value.length != 5) {
		alert("Attenzione il codice ABI deve essere di 5 caratteri");
		return false;
	}
	return true;
}
	
	
function verificaCAB() {
	var elem = document.getElementById("CAB");
	elem.value = elem.value.trim();
	if (elem.value.length != 5) {
		alert("Attenzione il codice CAB deve essere di 5 caratteri");
		return false;
	}
	return true;
}


function verificaCC() {
	var elem = document.getElementById("CC");
	elem.value = elem.value.trim();
	if (elem.value.length != 12) {
		alert("Attenzione il numero di C/C deve essere di 12 caratteri");
		return false;
	}
	return true;
}


function calcola() {
	//fa in modo che lo script termini se una verifica è negativa.
	if (!verificaABI() || ! verificaCAB()) {
		return false;
	}
	
	var elem = document.getElementById("CC");
	elem.value = elem.value.trim();
	while (elem.value.length < 12) {
		elem.value = "0" + elem.value;
	}
	calcolaIBANeCIN();
	return false; // non mandare il form
}


function elimina() {
	var elem = document.getElementById("risultati");
	elem.innerHTML = "";
	return true;
}